% -*- MATLAB -*-
% Time-stamp: "2017-10-19 07:20:26 fujiwara"
%----------------------------------------------------------------------
%  Copyright (C) 2015, FUJIWARA,Hiroshi
%    <fujiwara@acs.i.kyoto-u.ac.jp>
%----------------------------------------------------------------------

function b = uminus( a )

  [row,col] = size( a );

  for n=1:col
    for m=1:row

      x = exfloat( a(m,n) );
      b(m,n) = exfloat();
      b(m,n).num = x.num;
      if bitget( b(m,n).num(1), 64 ) == 0
        b(m,n).num(1) = x.num(1) + exfloat.SIGN;  % b(m,n) is positive
      else
          b(m,n).num(1) = x.num(1) - exfloat.SIGN; % b(m,n) is negative
      end

    end
  end

end

% debug, 2017/10/18
%
% It is not enough that b(m,n).num(1) = x.num(1) + exfloat.SIGN,
% without if-branch, for negative x.
% If x is negatie, e.g. x == -1, x.num(1) = 0x3f..ff + 0x80..00.
% And x.num(1) + exfloat.SIGN causes overflow as 64bit unsigned integer.
% and thus, x.num(1) + exfloat.SIGN = 0xff..ff in MATLAB,
% while we expect that overflow is neglected, the carry bit is neglected,
% and x.num(1) + exfloat.SIGN = 0x3f..ff.

%----------------------------------------------------------------------
% End of file
%----------------------------------------------------------------------
